/*******************************************************************************
 * FoxMagazinePickup generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxMagazinePickup extends FoxDroppedPickup_UIMesh
    native
    hidecategories(Navigation);

var array<byte> WeaponTypes;
var float RandomVelocitySize;

simulated function PostBeginPlay()
{
    local FoxPC PC;

    super.PostBeginPlay();
    // End:0x83
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0x82
        if(PC.myHUD != none)
        {
            PC.myHUD.AddPostRenderedActor(self);
        }        
    }    
    //return;    
}

function GiveTo(Pawn P)
{
    local int AmmoAdded, I;
    local FoxWeapon FW;
    local FoxPawn FP;
    local bool bAmmoAdded;

    FP = FoxPawn(P);
    // End:0x228
    if(((((FP != none) && FP.IsHumanControlled()) && FP.IsAliveAndWell()) && !FP.IsInjured()) && FoxInventoryManager(FP.InvManager) != none)
    {
        I = 0;
        J0xD4:
        // End:0x1F0 [Loop If]
        if(I < WeaponTypes.Length)
        {
            FW = FoxInventoryManager(P.InvManager).GetWeaponFromIndex(WeaponTypes[I]);
            // End:0x1E2
            if((FW != none) && !FW.bIsDepotWeapon)
            {
                AmmoAdded = FW.AddAmmo(int(FW.GetMagazineSize()));
                // End:0x1E2
                if(AmmoAdded > 0)
                {
                    bAmmoAdded = true;
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0xD4;
        }
        // End:0x228
        if(bAmmoAdded)
        {
            PlayAkEvent(PickupSound);
            PickedUpBy(P);
        }
    }
    //return;    
}

simulated function NotifyPickedUpByPRI()
{
    local FoxPC PC;

    super.NotifyPickedUpByPRI();
    // End:0x39
    if(PickupMesh != none)
    {
        PickupMesh.SetHidden(true);
    }
    // End:0xB2
    foreach LocalPlayerControllers(class'FoxPC', PC)
    {
        // End:0xB1
        if(PC.myHUD != none)
        {
            PC.myHUD.RemovePostRenderedActor(self);
        }        
    }    
    //return;    
}

function SetupAmmoPickup(optional byte NewWeaponType)
{
    NewWeaponType = 0;
    SetPhysics(2);
    Velocity = VRand() * RandomVelocitySize;
    Velocity.Z = RandomVelocitySize * float(2);
    //return;    
}

auto state Pickup
{
    function bool ValidTouch(Pawn Other)
    {
        local FoxWeapon WeaponToAddAmmo;
        local int I;

        // End:0xAA
        if((((Other == none) || !Other.IsHumanControlled()) || !Other.bCanPickupInventory) || (Other.DrivenVehicle == none) && Other.Controller == none)
        {
            return false;
        }
        // End:0xFF
        if(((Physics == 2) && Other == Instigator) && Velocity.Z > float(0))
        {
            return false;
        }
        // End:0x145
        if(!FastTrace(Other.Location, Location))
        {
            SetTimer(0.50, false, 'RecheckValidTouch');
            return false;
        }
        I = 0;
        J0x150:
        // End:0x2D4 [Loop If]
        if(I < WeaponTypes.Length)
        {
            WeaponToAddAmmo = ((FoxInventoryManager(Other.InvManager) != none) ? FoxInventoryManager(Other.InvManager).GetWeaponFromIndex(WeaponTypes[I]) : none);
            // End:0x2C6
            if(((WeaponToAddAmmo != none) && !WeaponToAddAmmo.bIsDepotWeapon) && (float(WeaponToAddAmmo.GetMaxSpareAmmoSize()) + WeaponToAddAmmo.GetMagazineSize()) > float(WeaponToAddAmmo.SpareAmmoCount + WeaponToAddAmmo.AmmoLeftCount))
            {
                return super.ValidTouch(Other);
            }
            ++ I;
            // [Loop Continue]
            goto J0x150;
        }
        return false;
        //return ReturnValue;        
    }
    stop;    
}

defaultproperties
{
    WeaponTypes(0)=0
    WeaponTypes(1)=1
    RandomVelocitySize=500.0
    BillboardClass=class'FoxBillboardUIAmmoPickup'
    PickupMeshReference="WPN_AmmoDropBox.Mesh.SM_AmmoDropBox"
    begin object name=StaticMesh0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxMagazinePickup.MyLightEnvironment'
        bCastDynamicShadow=false
        CollideActors=false
        BlockActors=false
        BlockZeroExtent=false
        BlockNonZeroExtent=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FoxMagazinePickup.StaticMesh0'
    PickupMesh=StaticMesh0
    PickupSound=AkEvent'WPN_AmmoDropBox.Play_Pickup_BotAmmo'
    begin object name=HRVMat class=MaterialInstanceConstant
        Parent=Material'FX_Characters.MT.MT_HVT_Noise'
        ParentLightingGuid=(A=-1709246918,B=1299300049,C=-518210160,D=408981621)
        LightingGuid=(A=596452855,B=1112368540,C=-2067439484,D=-1708230729)
    object end
    // Reference: MaterialInstanceConstant'Default__FoxMagazinePickup.HRVMat'
    HRVMaterial=HRVMat
    Components(0)=none
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=5.0
        CollisionRadius=15.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxMagazinePickup.CollisionCylinder'
    Components(1)=CollisionCylinder
    begin object name=MyLightEnvironment class=DynamicLightEnvironmentComponent
        bCastShadows=false
        bDynamic=false
        bSynthesizeSHLight=true
    object end
    // Reference: DynamicLightEnvironmentComponent'Default__FoxMagazinePickup.MyLightEnvironment'
    Components(2)=MyLightEnvironment
    begin object name=StaticMesh0 class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxMagazinePickup.MyLightEnvironment'
        bCastDynamicShadow=false
        CollideActors=false
        BlockActors=false
        BlockZeroExtent=false
        BlockNonZeroExtent=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FoxMagazinePickup.StaticMesh0'
    Components(3)=StaticMesh0
    begin object name=CollisionCylinder class=CylinderComponent
        CollisionHeight=5.0
        CollisionRadius=15.0
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxMagazinePickup.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}